config/routes.rb
# frozen_string_literal: true
Rails.application.routes.draw do
  resources :committees do
    match 'trials', to: 'trials#clear_permitted_trials', via: :delete, as: 'trial_clear_permitted'
    resources :trials do
      match 'state/:state_id', to: 'trials#set_state', via: :patch, as: 'set_state'
      match 'authorize/:private_key_digest', to: 'trials#receive_private_key_digest', via: :get,
                                             as: :authorize
      match '', to: 'trials#receive_private_key', via: :post
      match 'versions', to: 'trials#versions', via: :get
      match 'versions', to: 'trials#delete_versions', via: :delete
      match 'comment', to: 'trials#comment', via: :post
      resources :tasks, only: [:create, :update, :destroy, :edit]
      post 'upload', to: 'trials#upload'
    end
    resources :ranks, only: [:create, :destroy]
    resources :environments, only: [:create, :destroy, :edit, :update]
  end

  root 'home#index'
  match 'home/private_index' => 'home#private_index', via: :get
  match 'permitted_keywords' => 'home#permitted_keywords', via: :get

  # omniauth
  get '/auth/:provider/callback' => 'user_sessions#create'
  get '/auth/failure' => 'user_sessions#failure'

  # Custom logout
  match '/logout', to: 'user_sessions#destroy', via: :all
end

app/models/trial.rb
# frozen_string_literal: true
class Trial < ApplicationRecord # rubocop:disable Metrics/ClassLength
  # t.string   "title",                                        null: false
  # t.datetime "created_at",                                   null: false
  # t.datetime "updated_at",                                   null: false
  # t.integer  "committee_id",                                 null: false
  # t.date     "deadline"
  # t.string   "status",                   default: "pending", null: false
  # t.string   "email"
  # t.string   "phone_number"
  # t.string   "supervisor"
  # t.integer  "environment_id",                               null: false
  # t.string   "stateman_trial_id"
  # t.string   "private_key_digest"
  # t.string   "formsub_case_id"
  # t.string   "formsub_case_keyword"
  # t.integer  "rank_id",                                      null: false
  # t.integer  "stateman_state_id_cached"
  # t.string   "drive_folder"
  # t.boolean  "pending_changes",          default: false,     null: false
  # t.boolean  "formal_conditions",        default: false,     null: false
  # t.string   "supervisor_phone_number"
  # t.string   "supervisor_email"
  # t.string   "troop"
  # t.index ["committee_id"], name: "index_trials_on_committee_id", using: :btree
  # t.index ["private_key_digest"], name: "index_trials_on_private_key_digest",
  # unique: true, using: :btree
  # t.index ["rank_id"], name: "index_trials_on_rank_id", using: :btree

  # validations
  validates :title, presence: true, uniqueness: { scope: :committee }
  validates :committee, :deadline, :birthdate, presence: true
  validate :deadline_in_future, if: :deadline, on: :create
  STATUSES = %w(created pending accepted rejected).freeze
  validates :status, inclusion: { within: STATUSES, allow_nil: true }
  validates :email, :supervisor_email, presence: true, format: /@/
  validates :phone_number, :supervisor_phone_number, numericality: { only_integer: true },
                                                     length: { in: 9..13 }
  validates :supervisor, :troop, presence: true
  validates :rank, presence: true, if: proc { committee&.ranks.present? }
  validates :environment, presence: true, if: proc { committee&.environments.present? }
  validates :private_key_digest, uniqueness: true, allow_blank: true
  validates :private_key, presence: true, on: :create, unless: :private_key_digest?
  validates :formal_conditions, acceptance: true, if: proc { committee&.formal_conditions.present? }

  def deadline_in_future
    errors.add(:deadline, I18n.t(:deadline_in_future)) if deadline < 1.month.from_now
  end

  # relations
  belongs_to :committee
  belongs_to :rank
  belongs_to :environment
  has_many   :tasks

  # callbacks
  after_save       :create_stateman_trial, :create_formsub_case
  before_destroy   :destroy_stateman_trial, :destroy_formsub_case
  after_create     :send_notification
  after_create     :create_drive_folder

  # scopes
  STATUSES.each do |status|
    scope status, -> { where(status: status) }
  end

  # scoped for pending trials (combine status and dealine)
  scope :ongoing, -> { pending.where('deadline > ?', Time.zone.now) }
  scope :overdue_soon, -> { ongoing.where('deadline < ?', Time.zone.now + 1.month) }
  scope :overdue, -> { pending.where('deadline <= ?', Time.zone.now) }

  # rest instance methods
  STATUSES.each do |loop_status|
    define_method("#{loop_status}?") { status == loop_status }
  end

  attr_accessor :referer, :private_key
  has_paper_trail unless: :created?, ignore: %w(stateman_state_id_cached drive_folder
                                                pending_changes),
                  skip: %w(pending_changes_set! pending_changes_reset!)
  acts_as_commentable :public, :private
  acts_as_commentable

  def update_safe(attributes)
    return update(attributes) if created?
    pending_changes_set!
    update(attributes)
  end

  def can_become_pending?
    created? && tasks.present? && committee.min_trial_tasks_count <= tasks.count
  end

  def private_key=(value)
    return if value.blank?
    @private_key = "#{value}-#{SecureRandom.hex[0..2]}"
    self.private_key_digest = Digest::MD5.hexdigest(@private_key)
  end

  def stateman_trial
    return if stateman_trial_id.nil?
    @stateman_trial ||= find_stateman_trial
  end

  # rubocop:disable Style/AccessorMethodName
  def set_state_id(state_id)
    stateman_trial.update_attributes(item: { state_id: state_id },
                                     organization_id: committee.stateman.organization_id)
  end
  # rubocop:enable Style/AccessorMethodName

  def formsub_case
    create_formsub_case if formsub_case_id.nil?
    FormsubCase.find(formsub_case_id)
  end

  def committee
    @committee ||= super
  end

  def deadline_overdue
    # this method is responsible for auto changing state to overdue if deadline is passed
    # currently it is run from controller on show action
    # best way would be probably to use cron for this
    return unless deadline < Time.zone.now && stateman_state_id_cached != committee.overdue_state_id
    return unless stateman_trial.reachable_states.map(&:id).include? committee.overdue_state_id
    set_state_id(committee.overdue_state_id)
  end

  def drive_files
    create_drive_folder if drive_folder.blank?
    committee.drive.authorized.find_in_folder(drive_folder).files
  end

  def pending_changes_set!
    update(pending_changes: true)
  end

  def pending_changes_reset!
    update(pending_changes: false)
  end

  private

  def create_stateman_trial
    return unless stateman_trial_id.nil?
    stateman_trial = StatemanTrial.new(name: title)
    stateman_trial.prefix_options = { organization_id: committee.stateman.organization_id }

    update(stateman_trial_id: stateman_trial.id) if stateman_trial.save
  end

  def destroy_stateman_trial
    stateman_trial.destroy
  end

  def find_stateman_trial
    stateman_trial = StatemanTrial.find(stateman_trial_id, params: {
                                          organization_id: committee.stateman.organization_id
                                        })
    return stateman_trial if stateman_state_id_cached == stateman_trial.state.id
    update(stateman_state_id_cached: stateman_trial.state.id)
    stateman_trial
  end

  def create_formsub_case
    return unless committee.formsub_committee_id? && private_key_digest? && formsub_case_id.nil?
    formsub_case = FormsubCase.create(title: title, keyword: "#{id}-#{private_key_digest[0..2]}")

    return unless formsub_case.save
    update(formsub_case_id: formsub_case.id, formsub_case_keyword: formsub_case.keyword)
  end

  def destroy_formsub_case
    formsub_case.destroy if formsub_case_id?
  end

  def create_drive_folder
    return unless committee.drive_configured?
    folder = committee.drive.authorized.create_folder(title)
    update(drive_folder: folder.id)
  end

  def send_notification
    TrialNotificationMailer.created(self, @private_key).deliver
  end
end

app/controllers/trials_controller.rb
# frozen_string_literal: true
# rubocop:disable Metrics/ClassLength

require 'google_drive'
require 'differ/string'

class TrialsController < ApplicationController
  # Below actions are automatically un-authorized for blank users by TrialAuthorizer
  # Method skip_auth_actions is required for TrialAuthorizer access
  SKIP_AUTH_ACTIONS = %w(new create show edit update receive_private_key receive_private_key_digest
                         clear_permitted_trials upload comment).freeze

  include TrialAuthorizer, TrialCommentizer
  before_action :set_trial, only: %w(show edit update destroy upload receive_private_key_digest
                                     receive_private_key versions delete_versions comment)

  skip_before_action :login_required, only: SKIP_AUTH_ACTIONS

  # for private key based authentication on trial show
  before_action :set_session_permitted_trials, only: %w(receive_private_key
                                                        receive_private_key_digest
                                                        create)

  before_action :render_private_key_monit, only: [:show, :edit, :update, :upload, :comment],
                                           unless: :trial_authorized?
  before_action :set_comments, only: :show

  # GET /trials
  # GET /trials.json
  def index
    @trials = @committee.trials.includes(:rank, :environment)
    @stateman_trials = @committee.stateman.organization.stateman_trials
  end

  # GET /trials/1
  # GET /trials/1.json
  def show
    @trial.deadline_overdue
    @tasks = @trial.tasks
    @task = Task.new
    respond_to do |format|
      format.pdf do
        response.set_header('Content-type', 'application/octet-stream') if params[:download]
        @filename = "#{@trial.title}.pdf"
      end
      format.html
    end
  end

  # GET /trials/new
  def new
    @trial = Trial.new
  end

  # GET /trials/1/edit
  def edit; end

  # POST /trials
  # POST /trials.json
  # rubocop:disable Metrics/MethodLength
  def create
    @trial = Trial.new(trial_params)
    @trial.committee = @committee
    respond_to do |format|
      if @trial.save
        session['permitted_trials'] = session['permitted_trials'] | [@trial.private_key_digest]

        format.html do
          if current_user.present?
            redirect_to @trial.referer || [@committee, @trial],
                        notice: t(:trial_successfully_created)
          else
            redirect_to @trial.referer || committee_trial_authorize_path(@committee, @trial,
                                                                         @trial.private_key_digest),
                        notice: t(:trial_successfully_created)
          end
        end
        format.json { render :show, status: :created, location: @trial }
      else
        format.html { render :new }
        format.json { render json: @trial.errors, status: :unprocessable_entity }
      end
    end
  end
  # rubocop:enable Metrics/MethodLength

  # PATCH/PUT /trials/1
  # PATCH/PUT /trials/1.json
  def update
    respond_to do |format|
      if @trial.update_safe(trial_params)
        comment_update_action

        format.html do
          redirect_to @trial.referer || [@committee, @trial],
                      notice: t(:trial_successfully_updated)
        end
        format.json { render :show, status: :ok, location: @trial }
      else
        format.html { render :edit }
        format.json { render json: @trial.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /trials/1
  # PATCH/PUT /trials/1.json
  def set_state
    @trial = Trial.find(params[:trial_id])
    @old_state_name = @trial.stateman_trial.state.name

    respond_to do |format|
      if @trial.set_state_id(params[:state_id])
        comment_set_state_action

        format.html { redirect_to [@committee, @trial], notice: t(:state_was_successfully_updated) }
        format.json { head :ok }
      else
        format.html { redirect_to [@committee, @trial], notice: t(:state_couldnt_be_updated) }
        format.json { head :unprocessable_entity }
      end
    end
  end

  # DELETE /trials/1
  # DELETE /trials/1.json
  def destroy
    @trial.destroy
    respond_to do |format|
      format.html do
        redirect_to committee_trials_url(@committee),
                    notice: t(:trial_successfully_destroyed)
      end
      format.json { head :no_content }
    end
  end

  def receive_private_key_digest
    if trial_exists?
      session['permitted_trials'] = session['permitted_trials'] | [params[:private_key_digest]]
      redirect_to [@committee, @trial]
    else
      @trial.errors.add(:private_key, t(:must_be_correct))
      render 'private_key_monit'
    end
  end

  def receive_private_key
    if trial_params[:private_key].length == 32
      params['private_key_digest'] = trial_params[:private_key]
    else
      params['private_key_digest'] = Digest::MD5.hexdigest(trial_params[:private_key])
    end
    receive_private_key_digest
  end

  def clear_permitted_trials
    session['permitted_trials'] = []
    redirect_to @committee, notice: t(:your_trial_was_cleared)
  end

  def upload
    path = 'tmp/' + trial_params[:attachment].original_filename
    File.open(path, 'wb') do |file|
      file.write(trial_params[:attachment].read)
    end
    @committee.drive.authorized.upload_file(folder_id: @trial.drive_folder, upload_source: path,
                                            file_name: Time.zone.now.strftime('%Y%d%m%H%M%S') +
      " - #{trial_params[:name]} - " + trial_params[:attachment].original_filename)
    comment_upload_action

    redirect_to [@committee, @trial], notice: t(:file_sent)
  end

  def versions
    Differ.format = :html
  end

  def delete_versions
    @trial.versions.each(&:delete)
    @trial.tasks.each { |task| task.versions.each(&:delete) }
    @trial.pending_changes_reset!
    comment_delete_versions_action

    redirect_to [@committee, @trial], notice: t(:changes_accepted)
  end

  def comment
    @role = comment_params[:role]
    comment = comments.create(comment: comment_params[:body], title: 'comment', user: current_user,
                              committee: @committee)
    if comment.save
      redirect_to committee_trial_path(@committee, @trial, anchor: 'comments')
    else
      redirect_to [@committee, @trial], alert: t(:adding_comment_failed)
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_trial
    @trial = @committee.trials.find(params[:id] || params[:trial_id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def trial_params
    params.require(:trial).permit(
      %w(title deadline status referer email phone_number supervisor environment_id
         private_key rank_id attachment name drive_folder formal_conditions supervisor_phone_number
         supervisor_email troop birthdate)
    )
  end

  def comment_params
    params.require(:trial_comment).permit(:body, :role)
  end

  def trial_exists?
    Trial.exists?(private_key_digest: params[:private_key_digest], id: params[:trial_id])
  end

  def set_comments
    @comments = if current_user.present?
                  @trial.comments
                else
                  @trial.public_comments
                end
  end

  def skip_auth_actions
    SKIP_AUTH_ACTIONS
  end
end
# rubocop:enable Metrics/ClassLength

app/helpers/trials_helper.rb
# frozen_string_literal: true
module TrialsHelper
  def stateman_trial(trial, stateman_trials)
    stateman_trials.find { |st| st.id == trial.stateman_trial_id.to_i }
  end

  def style_for_trial_badge(trial, stateman_trials = nil)
    if stateman_trials.nil?
      "background-color: ##{trial.stateman_trial&.state&.color}"
    else
      "background-color: ##{stateman_trial(trial, stateman_trials)&.state&.color || 'red'}"
    end
  end

  def render_status_options?(trial)
    trial.committee.finish_state_ids.include? trial.stateman_state_id_cached
  end

  def drive_folder_url(trial)
    'https://drive.google.com/drive/u/0/folders/' + trial.drive_folder
  end
end

app/views/trials/_add_file_modal.html.haml
.modal.fade#add-file-modal{ 'aria-hidden': 'true',
'aria-labelledby': 'add-file-modal-label',
role: 'dialog', tabindex: '-1' }
  .modal-dialog{ role: 'document' }
    .modal-content
      .modal-header
        %h5.modal-title#add-file-modal-label
          = t(:add_file_title)
        %button.close{ 'aria-label': 'Close',
        'data-dismiss': 'modal', type: 'button' }
          %span{ 'aria-hidden': 'true' } ×
      = form_for(:trial, url: committee_trial_upload_path(committee,
      trial), html: { multipart: true }) do |f|
        .modal-body
          .field.form-group
            = f.label :name
            = f.text_field :name, value: nil, class: 'form-control'
          .field.form-group
            = f.label :attachment
            = f.file_field :attachment, class: 'form-control'
        .modal-footer
          %button.btn.btn-secondary{ 'data-dismiss': 'modal',
          type: 'button' }
            = t(:close)
          = f.submit t(:add), class: 'btn btn-primary'

app/views/trials/_comment_form.html.haml
= form_for :trial_comment, url: committee_trial_comment_path(@committee,
trial) do |f|
  .field.form-group
    = f.hidden_field :body
    %trix-editor{ input: 'trial_comment_body' }
  .field.form-group.float-left{ 'data-toggle': 'buttons' }
    - if current_user.present?
      = f.label :role, class: 'btn btn-outline-primary' do
        = f.radio_button('role', 'public')
        = t(:public)
      = f.label :role, class: 'btn btn-outline-primary active' do
        = f.radio_button('role', 'private', checked: 'checked')
        = t(:private)
  = f.submit t(:add_comment), class: 'btn btn-success float-right'

app/views/trials/_status_options.html.haml
- if trial.pending?
  - committee = trial.committee
  - if committee.positive_finish_state_id == trial.stateman_state_id_cached
    = form_for [committee, trial], html: { class: 'float-right' } do |f|
      = f.hidden_field :status, value: 'accepted'
      = f.hidden_field :referer, value: committee_trials_path(committee)
      = f.submit t(:accept), class: 'btn btn-sm btn-success'
  - if committee.negative_finish_state_id == trial.stateman_state_id_cached
    = form_for [committee, trial], html: { class: 'float-right' } do |f|
      = f.hidden_field :status, value: 'rejected'
      = f.hidden_field :referer, value: committee_trials_path(committee)
      = f.submit t(:reject), class: 'btn btn-sm btn-danger'

app/views/trials/edit.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs',
  locals: { final_title: t(:edit_trial) }

.row
  = render 'form', trial: @trial, ranks: @committee.ranks,
  environments: @committee.environments

app/views/trials/show.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs'

  = render 'shared/additional_menu' do
    - if @trial.created?
      - if @trial.can_become_pending? && !current_user.present?
        %button.btn.btn-primary{ 'data-target': '#mark-pending-modal',
        'data-toggle': 'modal', type: 'button' }
          %i.fa.fa-check
          %span= t(:mark_pending)
    - elsif !current_user.present?
      = link_to formsub_meetings_url,
      class: 'btn btn-success' do
        %i.fa.fa-plus-square-o
        %span= t(:register)
    - unless current_user.present?
      = link_to committee_trial_clear_permitted_path(@committee),
      method: :delete, class: 'btn btn-warning', 'data-toggle': 'tooltip',
      'data-placement': 'bottom', title: t(:clear_from_this_computer),
      data: { confirm: t(:confirm_forget_trials) } do
        %i.fa.fa-ban
        = t(:forget)
    = link_to edit_committee_trial_path(@committee, @trial),
    class: 'btn btn-secondary', 'data-toggle': 'tooltip',
    'data-placement': 'bottom', title: t(:edit_trial) do
      %i.fa.fa-edit
      %span.hidden-sm-up= t(:edit)

= render 'shared/alerts'
%hr.hidden-sm-up
.row.full-page-row
  .col-md-6
    .px-lg-5
      %ul.list-group
        %li.list-group-item.list-group-item-info
          %h4= @trial.title
        %li.list-group-item
          %b= t(:rank_colon)
          = @trial.rank&.name || t(:rank_missing)
          .ml-2.mr-2= '|'
          %b= t(:deadline_colon)
          = l(@trial.deadline, format: :month_year)
        %li.list-group-item
          %b= t(:email)
          = @trial.email
          .ml-2.mr-2= '|'
          %b= t(:phone_number)
          = @trial.phone_number
        %li.list-group-item
          %b= t(:environment_colon)
          = @trial.environment&.name || t(:environment_missing)
          .ml-2.mr-2= '|'
          %b= t(:troop_colon)
          = @trial.troop
        %li.list-group-item
          %b= t(:birthdate_colon)
          = @trial.birthdate
        %li.list-group-item
          %b= t(:supervisor)
          = @trial.supervisor
          (
          = @trial.supervisor_phone_number
          \/
          = mail_to @trial.supervisor_email
          )
        - if current_user&.admin?
          %li.list-group-item
            %b= t(:status)
            = @trial.status
        %li.list-group-item
          %b= t(:private_key_digest)
          = @trial.private_key_digest
        %li.list-group-item
          %b= t(:created_at)
          = l(@trial.created_at, format: :short)
          .ml-2.mr-2= '|'
          %b= t(:updated_at)
          = l(@trial.updated_at, format: :short)
  .col-md-6
    - unless @trial.valid?
      .alert.alert-danger{ role: 'alert' }
        = @trial.errors.full_messages.join('. ')
        = link_to t(:edit), edit_committee_trial_path(@committee, @trial),
        class: 'btn btn-secondary btn-sm float-right'
    - if @trial.created? && !current_user.present?
      .ls40
      %h4= [t(:states_general), t(:registrations)].to_sentence
      %hr
      %p.text-justify.pr-5= t(:more_functionalities_available_after_confirm)
      %p.text-justify
        %b= t(:more_functionalities_available_after_confirm2)
      = link_to t(:tasks), '#tasks', class: 'btn btn-primary'
      %hr
    - else
      - if @trial.pending_changes?
        .alert.alert-warning{ role: 'alert' }
          = t(:pending_changes_alert)
          - if current_user.present?
            = link_to committee_trial_versions_path(@committee, @trial),
            class: 'btn btn-sm btn-secondary float-right' do
              = t(:trial_changes)
        .ls20
      .hidden-md-up.ls40
      .px-lg-5
        %ul.list-group
          %li.list-group-item.list-group-item-info
            %h4= [t(:states_general), t(:files_general)].to_sentence
          %li.list-group-item
            %b= t(:state_colon)
            - if @trial.stateman_trial.present?
              - current_state = @trial.stateman_trial.state
              %span.badge.badge-default.pointer{ title: current_state.name,
              'data-toggle': 'popover', style: style_for_trial_badge(@trial),
              'data-content': current_state.description,
              'data-trigger': 'hover click', 'data-placement': 'top' }
                = current_state.name.split.first
            - else
              = t(:missing_state)
          %li.list-group-item
            %b= t(:reachable_states_colon)
            - if @trial.stateman_trial.present?
              - if current_user.present?
                - @trial.stateman_trial.reachable_states.each do |state|
                  = link_to state.name.split.first,
                  committee_trial_set_state_path(@committee, @trial, state.id),
                  data: { confirm: t(:confirm_state_update,
                  state: state.name) }, class: 'btn btn-secondary btn-state',
                  method: :patch, title: state.name,
                  'data-toggle': 'popover', 'data-trigger': 'hover',
                  'data-content': state.description, 'data-placement': 'bottom',
                  style: "background-color: ##{state.color}"
              - else
                = @trial.stateman_trial.reachable_states.map(&:name).to_sentence
            - else
              :javascript
                alert('#{t(:missing_state_try_update)}')
          - if @committee.drive_configured?
            - if @trial.drive_folder.present?
              %li.list-group-item
                .btn-group
                  = link_to t(:open_folder), drive_folder_url(@trial),
                  class: 'btn btn-info', target: '_blank'
                  %button.btn.btn-success{ 'data-target': '#add-file-modal',
                  'data-toggle': 'modal', type: 'button' }
                    = t(:add_file)
                  - if current_user.present?
                    = form_for([@committee, @trial]) do |f|
                      = f.hidden_field :drive_folder, value: ''
                      = f.submit t(:clear_drive), class: 'btn btn-warning',
                      title: t(:clear_drive_tooltip), 'data-toggle': 'tooltip'
                - if @trial.drive_files.present?
                  %li.list-group-item
                    = t(:files_saved, count: @trial.drive_files.count)
                    \:
                    = @trial.drive_files.map(&:name).to_sentence
            - else
              %li.list-group-item
                = t(:no_folder_added)
                / this line is responsible for adding drive folder on refresh
                - @trial.drive_files
          - else
            %li.list-group-item
              = t(:missing_drive_info)
          %li.list-group-item
            .btn-group
              = link_to t(:trial_as_pdf), committee_trial_path(@committee,
              @trial, format: 'pdf'), class: 'btn btn-secondary',
              target: '_blank'
              = link_to t(:trial_download_pdf), committee_trial_path(@committee,
              @trial, download: true, format: 'pdf'), class: 'btn btn-secondary'
      .ls40
      %h4= t(:registrations)
      %hr
      - if @trial.formsub_case.registrations.empty?
        = t(:no_registrations)
        - unless current_user.present?
          \ -
          = link_to t(:new_registration), formsub_meetings_url
        %hr
      - else
        - @trial.formsub_case.registrations.each do |registration|
          %b= registration.title
          = registration.meeting&.name || t(:registration_deleted)
          - if registration.meeting.present?
            (
            = l(registration.meeting.time_start.to_datetime, format: :short)
            \-
            = l(registration.meeting.time_end.to_datetime, format: :short)
            )
          %p= registration.description
          %hr
%hr#tasks
.ls40
.row.full-page-row
  .col-lg-8.offset-lg-2
    %nav.navbar.navbar-inverse.bg-info.mb-0
      .navbar-brand= t(:tasks)
    .table-responsive
      %table.table.table-bordered
        %thead
          %tr
            %th #
            %th= t(:task_content)
            %th= t(:deadline_short)
            %th.bg-success.td-square.pointer{ 'data-toggle': 'modal',
            'data-target': '#new-task-modal' }
              .btn.btn-sm
                %i.fa.fa-plus-square-o
        - @tasks.each do |task|
          %tr.show-on-hover-parent
            %td= task.number
            %td= task.content
            %td= l(task.deadline, format: :month_year)
            %td.td-square
              .show-on-hover
                = link_to [:edit, @committee, @trial, task], title: t(:edit),
                class: 'btn btn-sm btn-secondary', 'data-toggle': 'tooltip',
                'data-placement': 'bottom' do
                  %i.fa.fa-edit
                  %span.hidden-sm-up= t(:edit)
.ls40
%hr#comments
.ls40
.row.full-page-row
  .col-lg-8.offset-lg-2
    %nav.navbar.navbar-inverse.bg-info.mb-0
      .navbar-brand= t(:comments)
    .ls20
    - @comments.each do |comment|
      .comment
        - unless comment.title == 'history'
          = comment.user&.email || t(:candidate)
          = t(:commented)
          = l(comment.created_at, format: :short)
          %i= t(comment.role) if current_user.present?
        %p
          = l(comment.created_at, format: :short) if comment.title == 'history'
          = sanitize_trix_html comment.comment
      %hr
    = render 'comment_form', trial: @trial

= render 'tasks/new'
= render 'mark_pending_modal', committee: @committee, trial: @trial
= render 'add_file_modal', committee: @committee, trial: @trial

:javascript
  $("[href='#tasks']").click(function(event) {
    event.preventDefault();
    $('html, body').animate({
      scrollTop: $("#tasks").offset().top
    }, 500);
  });

- if @tasks.count.zero?
  :javascript
    $('[data-target="#new-task-modal"] .btn').attr({
    title: '#{t(:click_to_add_task)}',
    'data-toggle': 'tooltip'}).tooltip({ placement: 'left',
    html: true, offset: '-15 15', container: 'body' }).tooltip('show')

app/views/trials/versions.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs', locals: { final_title: t(:versions) }

  = render 'shared/additional_menu' do
    = link_to committee_trial_path(@committee, @trial),
    class: 'btn btn-secondary' do
      %i.fa.fa-arrow-left
      %span= t(:trial)
    = link_to committee_trial_versions_path(@committee, @trial),
    method: :delete, data: { confirm: t(:confirm_versions_delete) },
    class: 'btn btn-success' do
      %i.fa.fa-check
      %span= t(:accept_all_changes)
.ls40.hidden-sm-up

.container
  .row
    .col-lg-8.offset-lg-2
      %h2= t(:basic_info)
      %hr
      - @trial.versions.each do |version|
        = render 'change_card', version: version
      - if @trial.versions.empty?
        %p= t(:no_changes)

      .ls20
      %h2= t(:tasks)
      - @trial.tasks.each do |task|
        - task.versions.each do |version|
          = render 'change_card', version: version